/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.methodName;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Frequency</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.xtext.example.methodname.methodName.MethodNamePackage#getFrequency()
 * @model
 * @generated
 */
public enum Frequency implements Enumerator
{
  /**
   * The '<em><b>ALWAYS</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ALWAYS_VALUE
   * @generated
   * @ordered
   */
  ALWAYS(0, "ALWAYS", "always"),

  /**
   * The '<em><b>VERYOFTEN</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #VERYOFTEN_VALUE
   * @generated
   * @ordered
   */
  VERYOFTEN(1, "VERYOFTEN", "very-often"),

  /**
   * The '<em><b>OFTE</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #OFTE_VALUE
   * @generated
   * @ordered
   */
  OFTE(2, "OFTE", "often"),

  /**
   * The '<em><b>RARELY</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #RARELY_VALUE
   * @generated
   * @ordered
   */
  RARELY(3, "RARELY", "rarely"),

  /**
   * The '<em><b>VERYSELDOM</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #VERYSELDOM_VALUE
   * @generated
   * @ordered
   */
  VERYSELDOM(4, "VERYSELDOM", "very-seldom"),

  /**
   * The '<em><b>NEVER</b></em>' literal object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #NEVER_VALUE
   * @generated
   * @ordered
   */
  NEVER(5, "NEVER", "never");

  /**
   * The '<em><b>ALWAYS</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #ALWAYS
   * @model literal="always"
   * @generated
   * @ordered
   */
  public static final int ALWAYS_VALUE = 0;

  /**
   * The '<em><b>VERYOFTEN</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #VERYOFTEN
   * @model literal="very-often"
   * @generated
   * @ordered
   */
  public static final int VERYOFTEN_VALUE = 1;

  /**
   * The '<em><b>OFTE</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #OFTE
   * @model literal="often"
   * @generated
   * @ordered
   */
  public static final int OFTE_VALUE = 2;

  /**
   * The '<em><b>RARELY</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #RARELY
   * @model literal="rarely"
   * @generated
   * @ordered
   */
  public static final int RARELY_VALUE = 3;

  /**
   * The '<em><b>VERYSELDOM</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #VERYSELDOM
   * @model literal="very-seldom"
   * @generated
   * @ordered
   */
  public static final int VERYSELDOM_VALUE = 4;

  /**
   * The '<em><b>NEVER</b></em>' literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #NEVER
   * @model literal="never"
   * @generated
   * @ordered
   */
  public static final int NEVER_VALUE = 5;

  /**
   * An array of all the '<em><b>Frequency</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private static final Frequency[] VALUES_ARRAY =
    new Frequency[]
    {
      ALWAYS,
      VERYOFTEN,
      OFTE,
      RARELY,
      VERYSELDOM,
      NEVER,
    };

  /**
   * A public read-only list of all the '<em><b>Frequency</b></em>' enumerators.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static final List<Frequency> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

  /**
   * Returns the '<em><b>Frequency</b></em>' literal with the specified literal value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param literal the literal.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static Frequency get(String literal)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      Frequency result = VALUES_ARRAY[i];
      if (result.toString().equals(literal))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Frequency</b></em>' literal with the specified name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param name the name.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static Frequency getByName(String name)
  {
    for (int i = 0; i < VALUES_ARRAY.length; ++i)
    {
      Frequency result = VALUES_ARRAY[i];
      if (result.getName().equals(name))
      {
        return result;
      }
    }
    return null;
  }

  /**
   * Returns the '<em><b>Frequency</b></em>' literal with the specified integer value.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the integer value.
   * @return the matching enumerator or <code>null</code>.
   * @generated
   */
  public static Frequency get(int value)
  {
    switch (value)
    {
      case ALWAYS_VALUE: return ALWAYS;
      case VERYOFTEN_VALUE: return VERYOFTEN;
      case OFTE_VALUE: return OFTE;
      case RARELY_VALUE: return RARELY;
      case VERYSELDOM_VALUE: return VERYSELDOM;
      case NEVER_VALUE: return NEVER;
    }
    return null;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final int value;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String name;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private final String literal;

  /**
   * Only this class can construct instances.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  private Frequency(int value, String name, String literal)
  {
    this.value = value;
    this.name = name;
    this.literal = literal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int getValue()
  {
    return value;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getLiteral()
  {
    return literal;
  }

  /**
   * Returns the literal value of the enumerator, which is its string representation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    return literal;
  }
  
} //Frequency
